import subprocess,time

# 搜索附近的蓝牙设备
def connect_bluetooth(address):
   result = subprocess.run(['bluetoothctl', 'default-agent'], stdout=subprocess.PIPE)
   result = subprocess.run(['bluetoothctl', 'power', 'on'], stdout=subprocess.PIPE)
   result = subprocess.run(['bluetoothctl', 'pair', address], stdout=subprocess.PIPE)
   result=subprocess.run(['bluetoothctl', 'connect', address], stdout=subprocess.PIPE)
   print(result)
   print("蓝牙连接已完成")

def is_connected(device_mac):
   # 获取已配对的设备列表
   result = subprocess.run(['bluetoothctl', 'paired-devices'], stdout=subprocess.PIPE)
   paired_devices = result.stdout.decode().strip().split('\n')[1:]  # 跳过标题行

   # 遍历已配对的设备，检查MAC地址
   for device in paired_devices:
       if device_mac in device:
           # 如果设备已配对，检查是否已连接
           result = subprocess.run(['bluetoothctl', 'info', device_mac], stdout=subprocess.PIPE)
           info = result.stdout.decode().strip().split('\n')
           for line in info:
               if "Connected: yes" in line:
                   return True
   return False
# 你的蓝牙音箱的MAC地址
speaker_mac = "08:D0:03:96:70:8D"#收音机音箱BT-SPEAKER
#speaker_mac ="41:42:BE:4A:B6:C1"#海螺音箱X8s
#speaker_mac ="5A:5A:5A:A7:01:CA"#话筒音箱

connect_bluetooth(speaker_mac)

   
while True:
   time.sleep(0.1)
#特别注意：使用本程序前，要打开蓝牙音箱，使用行空板的命令行，bluetoothctl，再用scan on扫描一下，当扫描到蓝牙音箱后，scan off，exit。以后便可直接使用本程序。

#先用手机搜索蓝牙音箱，查看蓝牙音箱名称。如X8
#使用 PowerShell：
#打开 PowerShell。可以在开始菜单中搜索 “PowerShell”，然后右键选择 “以管理员身份运行”。
#输入以下命令：Get-PnpDevice -Class Bluetooth | Select-Object FriendlyName,InstanceId,Status,DeviceID。这个命令会列出系统中检测到的蓝牙设备的相关信息，包括设备名称、实例 ID、状态和设备 ID 等，你可以根据设备名称等信息来确定你想要获取 MAC 地址的蓝牙设备。
#X8 Avrcp 传输                          BTHENUM\{0000110C-0000-1000-8000-00805F9B34FB}_LOCALMFG&0002\7&4000742&0&4142BE4AB6C1_C00000000
#X8                                     BTHENUM\DEV_4142BE4AB6C1\7&4000742&0&BLUETOOTHDEVICE_4142BE4AB6C1
#4142BE4AB6C1，这个就是蓝牙音箱的MAC地址。
